-- Function: utility.sp_disable_macros(name, name, character varying)

-- DROP FUNCTION utility.sp_disable_macros(name, name, character varying);

CREATE OR REPLACE FUNCTION utility.sp_disable_macros(ip_object_schema name, ip_object_name name, ip_macro_type character varying)
  RETURNS void AS
$BODY$
DECLARE
    l_exeption_name VARCHAR(25);
BEGIN

    IF (ip_object_schema IN('pg_catalog','pg_toast','pg_temp_1','pg_toast_temp_1','information_schema')) THEN
        RAISE EXCEPTION 'Invalid schema passed into input variable ip_object_schema. Only non-system schemas can be passed in.';
    END IF;
    --Manipulate the starting commnet
    UPDATE pg_proc
    SET prosrc = REPLACE(prosrc,'--/*#IFDEF(' || ip_macro_type|| '=ON)','/*#IFDEF(' || ip_macro_type || '=OFF)')
    FROM pg_namespace
    WHERE pg_namespace.nspowner = pg_proc.proowner
      AND pg_namespace.nspname = ip_object_schema       --input parameter
      AND ( pg_proc.proname = ip_object_name AND pg_proc.proname NOT IN ('sp_enable_macros','sp_disable_macros')); --input parameter

    --Manipulate the ending comment
    UPDATE pg_proc
    SET prosrc = REPLACE(prosrc,'--#ENDIFDEF(' || ip_macro_type || '=ON)*/','#ENDIFDEF(' || ip_macro_type || '=OFF)*/')
    FROM pg_namespace
    WHERE pg_namespace.nspowner = pg_proc.proowner
      AND pg_namespace.nspname = ip_object_schema       --input parameter
      AND ( pg_proc.proname = ip_object_name AND pg_proc.proname NOT IN ('sp_enable_macros','sp_disable_macros')); --input parameter

EXCEPTION
   WHEN OTHERS THEN RAISE EXCEPTION 'An exception occured in utility.sp_disable_macros. %',SQLERRM; 
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION utility.sp_disable_macros(name, name, character varying) OWNER TO postgres;
